/**
 * Misc utility functions.
 *
 * Part of the basebox sample Todo app.
 * https://basebox.tech
 */
import {Modal} from "bootstrap";

/**
 * Show a message box (Bootstrap modal).
 *
 * The markup for the modal is defined in App.vue.
 */
export function showModal(title, text) {
  const el = document.getElementById('msgbox');
  el.querySelector(".modal-title").innerHTML = title;
  el.querySelector(".modal-body").innerHTML = text;
  const modal = new Modal(el);
  modal.show();
}

